Index: trunk/Cosmo/SimLSS/agnjackson.cc
===================================================================
--- trunk/Cosmo/SimLSS/agnjackson.cc	(revision 3324)
+++ trunk/Cosmo/SimLSS/agnjackson.cc	(revision 3325)
@@ -1,3 +1,2 @@
-#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
@@ -16,4 +15,5 @@
 #include "agnjackson.h"
 
+namespace SOPHYA {
 
 AGNJackson::AGNJackson(void)
@@ -95,2 +95,4 @@
   yjack = yjack_;
 }
+
+}  // Fin namespace SOPHYA
Index: trunk/Cosmo/SimLSS/agnjackson.h
===================================================================
--- trunk/Cosmo/SimLSS/agnjackson.h	(revision 3324)
+++ trunk/Cosmo/SimLSS/agnjackson.h	(revision 3325)
@@ -35,5 +35,5 @@
 };
 
-}
+}  // Fin namespace SOPHYA
 
 #endif
Index: trunk/Cosmo/SimLSS/cosmocalc.cc
===================================================================
--- trunk/Cosmo/SimLSS/cosmocalc.cc	(revision 3324)
+++ trunk/Cosmo/SimLSS/cosmocalc.cc	(revision 3325)
@@ -1,3 +1,2 @@
-#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
@@ -15,4 +14,5 @@
 #include "geneutils.h"
 
+namespace SOPHYA {
 
 ///////////////////////////////////////////////////////////
@@ -456,2 +456,4 @@
   return _nspl;
 }
+
+}  // Fin namespace SOPHYA
Index: trunk/Cosmo/SimLSS/cosmocalc.h
===================================================================
--- trunk/Cosmo/SimLSS/cosmocalc.h	(revision 3324)
+++ trunk/Cosmo/SimLSS/cosmocalc.h	(revision 3325)
@@ -96,5 +96,5 @@
 };
 
-} // Fin du namespace
+} // Fin du namespace SOPHYA
 
 #endif
Index: trunk/Cosmo/SimLSS/genefluct3d.cc
===================================================================
--- trunk/Cosmo/SimLSS/genefluct3d.cc	(revision 3324)
+++ trunk/Cosmo/SimLSS/genefluct3d.cc	(revision 3325)
@@ -1,3 +1,2 @@
-#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
@@ -28,4 +27,6 @@
 
 #define MODULE2(_x_) ((double)((_x_).real()*(_x_).real() + (_x_).imag()*(_x_).imag()))
+
+namespace SOPHYA {
 
 //-------------------------------------------------------
@@ -1323,2 +1324,4 @@
  if(intercor!=NULL) delete intercor;
 }
+
+}  // Fin namespace SOPHYA
Index: trunk/Cosmo/SimLSS/genefluct3d.h
===================================================================
--- trunk/Cosmo/SimLSS/genefluct3d.h	(revision 3324)
+++ trunk/Cosmo/SimLSS/genefluct3d.h	(revision 3325)
@@ -169,5 +169,5 @@
 };
 
-} // Fin du namespace
+} // Fin du namespace SOPHYA
 
 #endif
Index: trunk/Cosmo/SimLSS/genericfunc.h
===================================================================
--- trunk/Cosmo/SimLSS/genericfunc.h	(revision 3324)
+++ trunk/Cosmo/SimLSS/genericfunc.h	(revision 3325)
@@ -40,5 +40,5 @@
 };
 
-}
+}  // Fin namespace SOPHYA
 
 #endif
Index: trunk/Cosmo/SimLSS/geneutils.cc
===================================================================
--- trunk/Cosmo/SimLSS/geneutils.cc	(revision 3324)
+++ trunk/Cosmo/SimLSS/geneutils.cc	(revision 3325)
@@ -1,3 +1,2 @@
-#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
@@ -15,4 +14,6 @@
 
 #include "geneutils.h"
+
+namespace SOPHYA {
 
 //-------------------------------------------------------------------
@@ -461,2 +462,4 @@
    }
 }
+
+}  // Fin namespace SOPHYA
Index: trunk/Cosmo/SimLSS/geneutils.h
===================================================================
--- trunk/Cosmo/SimLSS/geneutils.h	(revision 3324)
+++ trunk/Cosmo/SimLSS/geneutils.h	(revision 3325)
@@ -76,6 +76,4 @@
 };
 
-}
-
 //----------------------------------------------------
 double InterpTab(double x0,vector<double>& X,vector<double>& Y,unsigned short typint=0);
@@ -101,3 +99,5 @@
 void Compute_GaussLeg(unsigned short glorder,vector<double>& x,vector<double>& w,double x1=0.,double x2=1.);
 
+}  // Fin namespace SOPHYA
+
 #endif
Index: trunk/Cosmo/SimLSS/pkspectrum.cc
===================================================================
--- trunk/Cosmo/SimLSS/pkspectrum.cc	(revision 3324)
+++ trunk/Cosmo/SimLSS/pkspectrum.cc	(revision 3325)
@@ -1,3 +1,2 @@
-#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
@@ -14,4 +13,5 @@
 #include "pkspectrum.h"
 
+namespace SOPHYA {
 
 ///////////////////////////////////////////////////////////
@@ -668,2 +668,4 @@
   return rc;
 }
+
+}  // Fin namespace SOPHYA
Index: trunk/Cosmo/SimLSS/pkspectrum.h
===================================================================
--- trunk/Cosmo/SimLSS/pkspectrum.h	(revision 3324)
+++ trunk/Cosmo/SimLSS/pkspectrum.h	(revision 3325)
@@ -145,5 +145,5 @@
 };
 
-} // Fin du namespace
+} // Fin du namespace SOPHYA
 
 #endif
Index: trunk/Cosmo/SimLSS/planckspectra.cc
===================================================================
--- trunk/Cosmo/SimLSS/planckspectra.cc	(revision 3324)
+++ trunk/Cosmo/SimLSS/planckspectra.cc	(revision 3325)
@@ -1,3 +1,2 @@
-#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
@@ -11,4 +10,6 @@
 #include "constcosmo.h"
 #include "planckspectra.h"
+
+namespace SOPHYA {
 
 /*
@@ -336,2 +337,4 @@
   return xmax;
 }
+
+}  // Fin namespace SOPHYA
Index: trunk/Cosmo/SimLSS/planckspectra.h
===================================================================
--- trunk/Cosmo/SimLSS/planckspectra.h	(revision 3324)
+++ trunk/Cosmo/SimLSS/planckspectra.h	(revision 3325)
@@ -41,5 +41,5 @@
 };
 
-} // Fin du namespace
+} // Fin du namespace SOPHYA
 
 #endif
Index: trunk/Cosmo/SimLSS/schechter.cc
===================================================================
--- trunk/Cosmo/SimLSS/schechter.cc	(revision 3324)
+++ trunk/Cosmo/SimLSS/schechter.cc	(revision 3325)
@@ -1,3 +1,2 @@
-#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
@@ -16,4 +15,6 @@
 #include "geneutils.h"
 #include "schechter.h"
+
+namespace SOPHYA {
 
 ///////////////////////////////////////////////////////////
@@ -401,5 +402,4 @@
 }
 
-
 ///////////////////////////////////////////////////////////
 //***************** Fonctions de Check ******************//
@@ -457,2 +457,4 @@
 }
 
+
+}  // Fin namespace SOPHYA
Index: trunk/Cosmo/SimLSS/schechter.h
===================================================================
--- trunk/Cosmo/SimLSS/schechter.h	(revision 3324)
+++ trunk/Cosmo/SimLSS/schechter.h	(revision 3325)
@@ -89,6 +89,4 @@
 };
 
-} // Fin du namespace
-
 //-----------------------------------------------------------------------------------
 bool IsCompatible(Schechter& sch1,Schechter& sch2,double eps=1.e-4);
@@ -98,3 +96,5 @@
 double FluxHI2Msol(double f,double d);
 
+} // Fin du namespace SOPHYA
+
 #endif