Index: trunk/SophyaLib/HiStats/hist2err.cc
===================================================================
--- trunk/SophyaLib/HiStats/hist2err.cc	(revision 3337)
+++ trunk/SophyaLib/HiStats/hist2err.cc	(revision 3338)
@@ -18,7 +18,6 @@
 /*! Constructeur par defaut */
 Histo2DErr::Histo2DErr(void)
-: xmin_(1.), xmax_(-1.), dx_(0.)
-, ymin_(1.), ymax_(-1.), dy_(0.)
-, nx_(0), ny_(0), mMean(0)
+: xmin_(1.), xmax_(-1.), dx_(0.) , ymin_(1.), ymax_(-1.), dy_(0.)
+  , nx_(0), ny_(0), mMean(0)
 {
 }
@@ -28,5 +27,5 @@
 Histo2DErr::Histo2DErr(r_8 xmin,r_8 xmax,int_4 nx,r_8 ymin,r_8 ymax,int_4 ny)
 {
-  CreateOrResize(xmin,xmax,nx,ymin,ymax,ny);
+ CreateOrResize(xmin,xmax,nx,ymin,ymax,ny);
 }
 
@@ -34,5 +33,6 @@
 /*! Constructeur par copie */
 Histo2DErr::Histo2DErr(const Histo2DErr& H)
-: mMean(0)
+: xmin_(1.), xmax_(-1.), dx_(0.) , ymin_(1.), ymax_(-1.), dy_(0.)
+  , nx_(0), ny_(0), mMean(0)
 {
  if(H.nx_<=0 || H.ny_<=0) return;
@@ -77,4 +77,5 @@
  err2_ = 0.;
  ndata_ = 0.;
+ mMean = 0;
 }
 
Index: trunk/SophyaLib/HiStats/histerr.cc
===================================================================
--- trunk/SophyaLib/HiStats/histerr.cc	(revision 3337)
+++ trunk/SophyaLib/HiStats/histerr.cc	(revision 3338)
@@ -25,7 +25,6 @@
 /*! Constructeur d'un histo */
 HistoErr::HistoErr(r_8 xmin,r_8 xmax,int_4 nx)
-: mMean(0)
-{
-  CreateOrResize(xmin,xmax,nx);
+{
+ CreateOrResize(xmin,xmax,nx);
 }
 
@@ -33,5 +32,5 @@
 /*! Constructeur par copie */
 HistoErr::HistoErr(const HistoErr& H)
-: mMean(H.mMean)
+: xmin_(1.), xmax_(-1.), dx_(0.), nx_(0), mMean(0)
 {
  if(H.nx_<=0) return;
@@ -40,4 +39,5 @@
  err2_  = H.err2_; 
  ndata_ = H.ndata_; 
+ mMean = H.mMean;
 }
 
@@ -73,4 +73,5 @@
  err2_ = 0.;
  ndata_ = 0.;
+ mMean = 0;
 }
 
Index: trunk/SophyaLib/HiStats/smakefile
===================================================================
--- trunk/SophyaLib/HiStats/smakefile	(revision 3337)
+++ trunk/SophyaLib/HiStats/smakefile	(revision 3338)
@@ -4,5 +4,5 @@
  
 clean:
-	 rm -f $(SOPHYAOBJP)basedtable.o $(SOPHYAOBJP)datatable.o $(SOPHYAOBJP)fio_dtable.o $(SOPHYAOBJP)hisprof.o $(SOPHYAOBJP)hist2err.o $(SOPHYAOBJP)histerr.o $(SOPHYAOBJP)histinit.o $(SOPHYAOBJP)histos2.o $(SOPHYAOBJP)histos.o $(SOPHYAOBJP)ntupintf.o $(SOPHYAOBJP)ntuple.o $(SOPHYAOBJP)proxtuple.o $(SOPHYAOBJP)swppfdtable.o $(SOPHYAOBJP)xntuple.o
+	 rm -f $(SOPHYAOBJP)basedtable.o $(SOPHYAOBJP)datatable.o $(SOPHYAOBJP)fio_dtable.o $(SOPHYAOBJP)hisprof.o $(SOPHYAOBJP)hist2err.o $(SOPHYAOBJP)histerr.o $(SOPHYAOBJP)histinit.o $(SOPHYAOBJP)histos.o $(SOPHYAOBJP)histos2.o $(SOPHYAOBJP)ntupintf.o $(SOPHYAOBJP)ntuple.o $(SOPHYAOBJP)proxtuple.o $(SOPHYAOBJP)swppfdtable.o $(SOPHYAOBJP)xntuple.o
 	rm -f $(SOPHYALIBP)libHiStats.a
  
@@ -12,18 +12,19 @@
  
 $(SOPHYAOBJP)basedtable.o: basedtable.cc basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h \
   $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tmatrix.h \
@@ -40,18 +41,19 @@
  
 $(SOPHYAOBJP)datatable.o: datatable.cc datatable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h \
   $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tmatrix.h \
@@ -73,29 +75,29 @@
  
 $(SOPHYAOBJP)fio_dtable.o: fio_dtable.cc datatable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)objfio.h \
-  swppfdtable.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)objfio.h swppfdtable.h \
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)segdatablock.h \
@@ -103,12 +105,9 @@
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)ppftpointerio.h \
-  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fiosegdb.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fio_dtable.cc
  
-$(SOPHYAOBJP)hisprof.o: hisprof.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)hisprof.o: hisprof.cc $(SOPHYAINCP)machdefs.h \
   hisprof.h $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)machdefs.h \
@@ -141,7 +140,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  hisprof.cc
  
-$(SOPHYAOBJP)hist2err.o: hist2err.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)hist2err.o: hist2err.cc $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -165,12 +162,10 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  hist2err.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)tvector_tsnl.h hist2err.h \
+  $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)tmatrix.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  hist2err.cc
  
-$(SOPHYAOBJP)histerr.o: histerr.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)histerr.o: histerr.cc $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -194,13 +189,11 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  histerr.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)tvector_tsnl.h histerr.h \
+  $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)tvector.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histerr.cc
  
-$(SOPHYAOBJP)histinit.o: histinit.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  histinit.h \
+$(SOPHYAOBJP)histinit.o: histinit.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
@@ -232,12 +225,11 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)anydataobj.h \
-  histos2.h $(SOPHYAINCP)utils.h \
-  hisprof.h histerr.h hist2err.h \
-  $(SOPHYAINCP)tmatrix.h ntuple.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  xntuple.h datatable.h basedtable.h \
-  $(SOPHYAINCP)segdatablock.h \
-  swppfdtable.h \
+  $(SOPHYAINCP)anydataobj.h histos2.h \
+  $(SOPHYAINCP)utils.h hisprof.h histerr.h \
+  hist2err.h $(SOPHYAINCP)tmatrix.h ntuple.h \
+  ntupintf.h $(SOPHYAINCP)dvlist.h xntuple.h \
+  datatable.h basedtable.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h swppfdtable.h \
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)segdatablock.h \
@@ -247,7 +239,40 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histinit.cc
  
-$(SOPHYAOBJP)histos2.o: histos2.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)histos.o: histos.cc $(SOPHYAINCP)machdefs.h \
+  histos.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)utils.h \
+  $(SOPHYAINCP)perrors.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)perrors.h \
+  $(SOPHYAINCP)poly.h \
+  $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)strutil.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histos.cc
+ 
+$(SOPHYAOBJP)histos2.o: histos2.cc $(SOPHYAINCP)machdefs.h \
   histos2.h $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)machdefs.h \
@@ -280,52 +305,11 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histos2.cc
  
-$(SOPHYAOBJP)histos.o: histos.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h histos.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)peida.h \
-  $(SOPHYAINCP)utils.h \
-  $(SOPHYAINCP)perrors.h \
-  $(SOPHYAINCP)fmath.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)perrors.h \
-  $(SOPHYAINCP)poly.h \
-  $(SOPHYAINCP)peida.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)strutil.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histos.cc
- 
-$(SOPHYAOBJP)ntupintf.o: ntupintf.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  ntupintf.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)ntupintf.o: ntupintf.cc $(SOPHYAINCP)sopnamsp.h \
+  ntupintf.h $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)machdefs.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ntupintf.cc
  
-$(SOPHYAOBJP)ntuple.o: ntuple.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)strutil.h \
+$(SOPHYAOBJP)ntuple.o: ntuple.cc $(SOPHYAINCP)strutil.h \
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -337,6 +321,5 @@
   $(SOPHYAINCP)ppfbinstream.h \
   $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  ntupintf.h \
+  $(SOPHYAINCP)ppfnametag.h ntupintf.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)ppersist.h \
@@ -347,17 +330,14 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ntuple.cc
  
-$(SOPHYAOBJP)proxtuple.o: proxtuple.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  proxtuple.h ntuple.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  ntupintf.h \
+$(SOPHYAOBJP)proxtuple.o: proxtuple.cc $(SOPHYAINCP)sopnamsp.h \
+  proxtuple.h ntuple.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h ntupintf.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)ppersist.h \
@@ -369,18 +349,19 @@
  
 $(SOPHYAOBJP)swppfdtable.o: swppfdtable.cc swppfdtable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h \
   $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tmatrix.h \
@@ -402,7 +383,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  swppfdtable.cc
  
-$(SOPHYAOBJP)xntuple.o: xntuple.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)ppersist.h \
+$(SOPHYAOBJP)xntuple.o: xntuple.cc $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -413,6 +392,6 @@
   $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)perrors.h xntuple.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)anydataobj.h \